/*
 *    VisNow
 *    Copyright (C) 2006-2019 University of Warsaw, ICM
 *    Copyright (C) 2020 onward visnow.org
 *    All rights reserved. 
 *
 *  This file is part of GNU Classpath.
 *
 *  GNU Classpath is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2, or (at your option)
 *  any later version.
 *
 *  GNU Classpath is distributed in the hope that it will be useful, but
 *  WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with GNU Classpath; see the file COPYING.  If not, write to the
 *  University of Warsaw, Interdisciplinary Centre for Mathematical and
 *  Computational Modelling, Pawinskiego 5a, 02-106 Warsaw, Poland.
 *
 *  Linking this library statically or dynamically with other modules is
 *  making a combined work based on this library.  Thus, the terms and
 *  conditions of the GNU General Public License cover the whole
 *  combination.
 *
 *  As a special exception, the copyright holders of this library give you
 *  permission to link this library with independent modules to produce an
 *  executable, regardless of the license terms of these independent
 *  modules, and to copy and distribute the resulting executable under
 *  terms of your choice, provided that you also meet, for each linked
 *  independent module, the terms and conditions of the license of that
 *  module.  An independent module is a module which is not derived from
 *  or based on this library.  If you modify this library, you may extend
 *  this exception to your version of the library, but you are not
 *  obligated to do so.  If you do not wish to do so, delete this
 *  exception statement from your version.
 */
 
package org.visnow.vn.lib.gui.cropUI;

import java.util.ArrayList;
import java.util.Arrays;
import javax.swing.JFrame;
import javax.swing.WindowConstants;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;
import org.apache.log4j.Logger;
import org.visnow.vn.engine.core.ParameterProxy;
import org.visnow.vn.gui.widgets.SubRangeSlider.SubRangeModel;
import static org.visnow.vn.lib.gui.cropUI.CropUIShared.*;
import org.visnow.vn.system.main.VisNow;
import org.visnow.vn.system.swing.UIStyle;

/**
 *
 * @author Krzysztof S. Nowinski, University of Warsaw, ICM
 * Extended by Szpak to support:
 * {@link ParameterProxy} along with {@link #updateGUI(org.visnow.vn.engine.core.ParameterProxy, boolean) )}
 */
public class CropUI extends javax.swing.JPanel
{
    private ParameterProxy parameterProxy;

    private static final Logger LOGGER = Logger.getLogger(CropUI.class);
    boolean sleep = false;
    private boolean dynamic = false;
    private boolean lockInitialRange = true;
    private int[] initialXRange = null;
    private int[] initialYRange = null;
    private int[] initialZRange = null;

    /**
     * Creates new form CropUI
     */
    public CropUI()
    {
        initComponents();
    }

    public CropUI(boolean dynamic)
    {
        initComponents();
        this.dynamic = dynamic;
        xCropSlider.setExtent(2);
        xCropSlider.setPolicy(SubRangeModel.PUSH);
        yCropSlider.setExtent(2);
        yCropSlider.setPolicy(SubRangeModel.PUSH);
        zCropSlider.setExtent(2);
        zCropSlider.setPolicy(SubRangeModel.PUSH);
    }

    /**
     * This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents()
    {
        java.awt.GridBagConstraints gridBagConstraints;

        jLabel1 = new javax.swing.JLabel();
        xCropSlider = new org.visnow.vn.gui.widgets.SubRangeSlider.ExtendedSubRangeSlider();
        yCropSlider = new org.visnow.vn.gui.widgets.SubRangeSlider.ExtendedSubRangeSlider();
        zCropSlider = new org.visnow.vn.gui.widgets.SubRangeSlider.ExtendedSubRangeSlider();
        jLabel2 = new javax.swing.JLabel();
        jLabel3 = new javax.swing.JLabel();

        setBorder(javax.swing.BorderFactory.createTitledBorder("Crop"));
        setLayout(new java.awt.GridBagLayout());

        jLabel1.setText("I:");
        jLabel1.setVerticalAlignment(javax.swing.SwingConstants.TOP);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(4, 4, 0, 0);
        add(jLabel1, gridBagConstraints);

        xCropSlider.setBorder(null);
        xCropSlider.addChangeListener(new javax.swing.event.ChangeListener()
        {
            public void stateChanged(javax.swing.event.ChangeEvent evt)
            {
                xCropSliderStateChanged(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 4, 4);
        add(xCropSlider, gridBagConstraints);

        yCropSlider.setBorder(null);
        yCropSlider.addChangeListener(new javax.swing.event.ChangeListener()
        {
            public void stateChanged(javax.swing.event.ChangeEvent evt)
            {
                yCropSliderStateChanged(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 4, 4);
        add(yCropSlider, gridBagConstraints);

        zCropSlider.setBorder(null);
        zCropSlider.addChangeListener(new javax.swing.event.ChangeListener()
        {
            public void stateChanged(javax.swing.event.ChangeEvent evt)
            {
                zCropSliderStateChanged(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 4, 4);
        add(zCropSlider, gridBagConstraints);

        jLabel2.setText("J:");
        jLabel2.setVerticalAlignment(javax.swing.SwingConstants.TOP);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(4, 4, 0, 0);
        add(jLabel2, gridBagConstraints);

        jLabel3.setText("K:");
        jLabel3.setVerticalAlignment(javax.swing.SwingConstants.TOP);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(4, 4, 0, 0);
        add(jLabel3, gridBagConstraints);
    }// </editor-fold>//GEN-END:initComponents

    public void setParameterProxy(ParameterProxy p)
    {
        this.parameterProxy = p;
    }

    private void xCropSliderStateChanged(javax.swing.event.ChangeEvent evt)//GEN-FIRST:event_xCropSliderStateChanged
    {//GEN-HEADEREND:event_xCropSliderStateChanged
        if (lockInitialRange && initialXRange != null) {
            boolean fix = false;
            if (xCropSlider.getMin() < initialXRange[0]) {
                xCropSlider.setMin(initialXRange[0]);
                fix = true;
            }
            if (xCropSlider.getMax() > initialXRange[1]) {
                xCropSlider.setMax(initialXRange[1]);
                fix = true;
            }
            if (fix)
                return;
        }

        if ((!dynamic && xCropSlider.isAdjusting()) || sleep)
            return;
        fireStateChanged();
    }//GEN-LAST:event_xCropSliderStateChanged

    private void yCropSliderStateChanged(javax.swing.event.ChangeEvent evt)//GEN-FIRST:event_yCropSliderStateChanged
    {//GEN-HEADEREND:event_yCropSliderStateChanged
        if (lockInitialRange && initialYRange != null) {
            boolean fix = false;
            if (yCropSlider.getMin() < initialYRange[0]) {
                yCropSlider.setMin(initialYRange[0]);
                fix = true;
            }
            if (yCropSlider.getMax() > initialYRange[1]) {
                yCropSlider.setMax(initialYRange[1]);
                fix = true;
            }
            if (fix)
                return;
        }
        if ((!dynamic && yCropSlider.isAdjusting()) || sleep)
            return;
        fireStateChanged();
    }//GEN-LAST:event_yCropSliderStateChanged

    private void zCropSliderStateChanged(javax.swing.event.ChangeEvent evt)//GEN-FIRST:event_zCropSliderStateChanged
    {//GEN-HEADEREND:event_zCropSliderStateChanged
        if (lockInitialRange && initialZRange != null) {
            boolean fix = false;
            if (zCropSlider.getMin() < initialZRange[0]) {
                zCropSlider.setMin(initialZRange[0]);
                fix = true;
            }
            if (zCropSlider.getMax() > initialZRange[1]) {
                zCropSlider.setMax(initialZRange[1]);
                fix = true;
            }
            if (fix)
                return;
        }

        if ((!dynamic && zCropSlider.isAdjusting()) || sleep)
            return;
        fireStateChanged();
    }//GEN-LAST:event_zCropSliderStateChanged

    /**
     * Setter for property parent.
     * <p>
     * @param parent New value of property parent.
     */
    public void setNewExtents(int[] dims)
    {
        sleep = true;
        initialXRange = new int[]{0, dims[0] - 1};
        initialYRange = null;
        initialZRange = null;
        xCropSlider.setMin(0);
        xCropSlider.setMax(dims[0] - 1);
        xCropSlider.setLow(0);
        xCropSlider.setUp(dims[0] - 1);
        if (dims.length > 1) {
            initialYRange = new int[]{0, dims[1] - 1};
            yCropSlider.setMin(0);
            yCropSlider.setMax(dims[1] - 1);
            yCropSlider.setLow(0);
            yCropSlider.setUp(dims[1] - 1);
            yCropSlider.setEnabled(true);
        } else
            yCropSlider.setEnabled(false);
        if (dims.length > 2) {
            initialZRange = new int[]{0, dims[2] - 1};
            zCropSlider.setMin(0);
            zCropSlider.setMax(dims[2] - 1);
            zCropSlider.setLow(0);
            zCropSlider.setUp(dims[2] - 1);
            zCropSlider.setEnabled(true);
        } else
            zCropSlider.setEnabled(false);
        sleep = false;
    }

    /**
     * Setter for property parent.
     * <p>
     * @param dims        field dimensions
     * @param low         lower indices (inclusive)
     * @param up          upper indices (exclusive)
     * @param resetMinMax if true, then min and max values are reseted.
     */
    public void setNewExtents(int[] dims, int[] low, int[] up, boolean resetMinMax)
    {
        sleep = true;
        initialXRange = new int[]{0, dims[0] - 1};
        initialYRange = null;
        initialZRange = null;
        if (low[0] >= up[0] - 1 || low[0] < 0 || up[0] > dims[0])
            throw new IllegalArgumentException("Incorrect low/up: " + low[0] + " " + up[0] + " " + dims[0]);
        if (xCropSlider.getMin() > low[0] || resetMinMax) xCropSlider.setMin(0);
        if (xCropSlider.getMax() < up[0] - 1 || resetMinMax) xCropSlider.setMax(dims[0] - 1);
        xCropSlider.setLow(low[0]);
        xCropSlider.setUp(up[0] - 1);
        if (dims.length > 1) {
            if (low[1] >= up[1] - 1 || low[1] < 0 || up[1] > dims[1])
                throw new IllegalArgumentException("Incorrect low/up: " + low[1] + " " + up[1] + " " + dims[1]);
            initialYRange = new int[]{0, dims[1] - 1};
            if (yCropSlider.getMin() > low[1] || resetMinMax) yCropSlider.setMin(0);
            if (yCropSlider.getMax() < up[1] - 1 || resetMinMax) yCropSlider.setMax(dims[1] - 1);
            yCropSlider.setLow(low[1]);
            yCropSlider.setUp(up[1] - 1);
            yCropSlider.setEnabled(true);
        } else
            yCropSlider.setEnabled(false);
        if (dims.length > 2) {
            if (low[2] >= up[2] - 1 || low[2] < 0 || up[2] > dims[2])
                throw new IllegalArgumentException("Incorrect low/up: " + low[2] + " " + up[2] + " " + dims[2]);
            initialZRange = new int[]{0, dims[2] - 1};

            if (zCropSlider.getMin() > low[2] || resetMinMax) zCropSlider.setMin(0);
            if (zCropSlider.getMax() < up[2] - 1 || resetMinMax) zCropSlider.setMax(dims[2] - 1);
            zCropSlider.setLow(low[2]);
            zCropSlider.setUp(up[2] - 1);
            zCropSlider.setEnabled(true);
        } else
            zCropSlider.setEnabled(false);
        sleep = false;
    }

    public int[] getLow()
    {
        int[] low = new int[3];
        low[0] = xCropSlider.getLow();
        low[1] = yCropSlider.getLow();
        low[2] = zCropSlider.getLow();
        return low;
    }

    private int[] getHigh()
    {
        return new int[]{
            xCropSlider.getUp(),
            yCropSlider.getUp(),
            zCropSlider.getUp(),};
    }

    public int[] getUp()
    {
        int[] up = new int[3];
        up[0] = xCropSlider.getUp() + 1;
        up[1] = yCropSlider.getUp() + 1;
        up[2] = zCropSlider.getUp() + 1;
        return up;
    }

    public void setDynamic(boolean dynamic)
    {
        this.dynamic = dynamic;
    }

    public boolean isAdjusting()
    {
        return xCropSlider.isAdjusting() || yCropSlider.isAdjusting() || zCropSlider.isAdjusting();
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private org.visnow.vn.gui.widgets.SubRangeSlider.ExtendedSubRangeSlider xCropSlider;
    private org.visnow.vn.gui.widgets.SubRangeSlider.ExtendedSubRangeSlider yCropSlider;
    private org.visnow.vn.gui.widgets.SubRangeSlider.ExtendedSubRangeSlider zCropSlider;
    // End of variables declaration//GEN-END:variables

    /**
     * Utility field holding list of ChangeListeners.
     */
    private transient ArrayList<ChangeListener> changeListenerList
            = new ArrayList<ChangeListener>();

    /**
     * Registers ChangeListener to receive events.
     * <p>
     * @param listener The listener to register.
     */
    public synchronized void addChangeListener(ChangeListener listener)
    {
        changeListenerList.add(listener);
    }

    /**
     * Removes ChangeListener from the list of listeners.
     * <p>
     * @param listener The listener to remove.
     */
    public synchronized void removeChangeListener(ChangeListener listener)
    {
        changeListenerList.remove(listener);
    }

    /**
     * Notifies all registered listeners about the event.
     * <p>
     * @param object Parameter #1 of the <CODE>ChangeEvent<CODE> constructor.
     */
    private void fireStateChanged()
    {
        ChangeEvent e = new ChangeEvent(this);
        for (ChangeListener listener : changeListenerList)
            listener.stateChanged(e);

        if (parameterProxy != null) {
            parameterProxy.set(LOW, getLow(),
                               HIGH, getHigh());
        }
    }

    @Override
    public void setEnabled(boolean enabled)
    {
        xCropSlider.setEnabled(enabled);
        yCropSlider.setEnabled(enabled);
        zCropSlider.setEnabled(enabled);
    }

    /**
     * @return the lockInitialRange
     */
    public boolean isLockInitialRange()
    {
        return lockInitialRange;
    }

    /**
     * @param lockInitialRange the lockInitialRange to set
     */
    public void setLockInitialRange(boolean lockInitialRange)
    {
        this.lockInitialRange = lockInitialRange;
    }

    public void updateGUI(ParameterProxy p, boolean resetFully)
    {
        int[] dims = p.get(META_FIELD_DIMENSION_LENGTHS);
        int[] low = p.get(LOW);
        int[] high = p.get(HIGH);
        for (int i = 0; i < high.length; i++) //converting to [low, up) version
            high[i]++;

        setNewExtents(dims, low, high, resetFully);
    }

    public static void main(String[] args)
    {
        VisNow.initLogging(true);
        UIStyle.initStyle();
        JFrame f = new JFrame();
        f.setLocationRelativeTo(null);
        final CropUI p = new CropUI();
        p.addChangeListener(new ChangeListener()
        {
            @Override
            public void stateChanged(ChangeEvent e)
            {
                LOGGER.debug(Arrays.toString(p.getLow()) + " " + Arrays.toString(p.getUp()));
            }
        });
        f.add(p);
        f.pack();
        f.setDefaultCloseOperation(WindowConstants.EXIT_ON_CLOSE);

        f.setVisible(true);
    }

}
